package cn.citycraft.RealBackpacks.util;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.configuration.serialization.ConfigurationSerializable;
import org.bukkit.configuration.serialization.ConfigurationSerialization;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;

import com.google.gson.JsonIOException;

public class InvJsonUtils {
	public static String NullString = "|--空--|";
	public static String SplitString = "|-分割-|";
	
	public static String invToJson(Inventory inv) {
		List<String> json = invToList(inv);
		return JsonUtils.toJson(json);
	}
	
	public static List<String> stringToList(final String listString) {
		return Arrays.asList(listString.split(SplitString));
	}

	public static String listToString(final List<String> list) {
		String newString = null;
		for (final String s : list) {
			if (newString == null) {
				newString = s;
			} else {
				newString = newString + SplitString + s;
			}
		}
		return newString;
	}
	
	public static List<String> invToList(final Inventory inv) {
		final List<String> result = new ArrayList<String>();
		for (final ConfigurationSerializable item : inv.getContents()) {
			if (item == null) {
				result.add(NullString);
			} else {
				result.add(JsonUtils.toJson(serialize(item)).toString());
			}
		}
		return result;
	}
	
	@SuppressWarnings("unchecked")
	public static Inventory jsonToInv(String json ,String invname) {
		List<String> list = (List<String>) JsonUtils.toList(json);
		int size = list.size();
		Inventory inv = listToInventory(list, invname, size);
		return inv;
	}

	public static String itemToString(final ItemStack i) {
		return JsonUtils.toJson(serialize(i)).toString();
	}

	@SuppressWarnings("unchecked")
	public static Inventory listToInventory(final List<String> stringItems,
			final String name, final int size) {
		final Inventory inv = Bukkit.createInventory(null, size,
				ChatColor.translateAlternateColorCodes('&', name));
		final List<ItemStack> contents = new ArrayList<ItemStack>();
		for (final String piece : stringItems) {
			if (piece.equalsIgnoreCase(NullString)) {
				contents.add(null);
			} else {
				try {
					final ItemStack item = (ItemStack) deserialize((Map<String, Object>) JsonUtils
							.toMap(piece));
					contents.add(item);
				} catch (final JsonIOException e) {

				}
			}
		}
		final ItemStack[] items = new ItemStack[contents.size()];
		for (int x = 0; x < contents.size(); x++) {
			items[x] = contents.get(x);
		}
		inv.setContents(items);
		return inv;
	}

	public static Map<String, Object> serialize(final ConfigurationSerializable cs) {
		final Map<String, Object> serialized = recreateMap(cs.serialize());
		for (final Entry<String, Object> entry : serialized.entrySet()) {
			if (entry.getValue() instanceof ConfigurationSerializable) {
				entry.setValue(serialize((ConfigurationSerializable) entry.getValue()));
			}
		}
		serialized.put(ConfigurationSerialization.SERIALIZED_TYPE_KEY, ConfigurationSerialization.getAlias(cs.getClass()));
		return serialized;
	}

	public static Map<String, Object> recreateMap(final Map<String, Object> original) {
		final Map<String, Object> map = new HashMap<String, Object>();
		for (final Entry<String, Object> entry : original.entrySet()) {
			map.put(entry.getKey(), entry.getValue());
		}
		return map;
	}

	@SuppressWarnings({ "unchecked", "rawtypes" })
	public static ConfigurationSerializable deserialize(final Map<String, Object> map) {
		for (final Entry<String, Object> entry : map.entrySet()) {
			if (entry.getValue() instanceof Map && ((Map) entry.getValue()).containsKey(ConfigurationSerialization.SERIALIZED_TYPE_KEY)) {
				entry.setValue(deserialize((Map) entry.getValue()));
			}
		}
		return ConfigurationSerialization.deserializeObject(map);
	}

}
